// EcxLibDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EcxLib.h"
#include "EcxLibDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
//     CEcxLibDlg
/////////////////////////////////////////////////////////////////////////////
CEcxLibDlg* g_pEcxLibDlg;


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
CEcxLibDlg::CEcxLibDlg(CWnd* pParent) : CDialog(CEcxLibDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEcxLibDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	g_pEcxLibDlg = this;
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEcxLibDlg)
	DDX_Control(pDX, CMB_ENTRY, m_cmbEntry);
	DDX_Control(pDX, CMB_CRT, m_cmbCrt);
	DDX_Control(pDX, STA_COUNT, m_StatCount);
	DDX_Control(pDX, LIST_IN, m_ListFiles);
	//}}AFX_DATA_MAP
}


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
BEGIN_MESSAGE_MAP(CEcxLibDlg, CDialog)
	//{{AFX_MSG_MAP(CEcxLibDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BTN_CHECK_ALL, OnCheckAll)
	ON_BN_CLICKED(BTN_UNCHECK_ALL, OnUncheckAll)
	ON_BN_CLICKED(BTN_START, OnStart)
	ON_NOTIFY(LVN_ITEMCHANGED, LIST_IN, OnItemChanged)
	ON_WM_DESTROY()
	ON_NOTIFY(NM_DBLCLK, LIST_IN, OnDblclkIn)
	ON_NOTIFY(LVN_COLUMNCLICK, LIST_IN, OnColumnclickIn)
	ON_CBN_SELCHANGE(CMB_CRT, OnSelchangeCrt)
	ON_CBN_SELCHANGE(CMB_ENTRY, OnSelchangeEntry)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
BOOL CEcxLibDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	::SetWindowText(m_hWnd, ECX_LIBRARY);
	

	//   
	::GetModuleFileName(NULL, m_szPath, MAX_PATH);
	int len = strlen(m_szPath);
	while(m_szPath[len] != '\\') len--;
	m_szPath[len] = '\0';

	m_nCategory = 2;
	m_cmbCrt.SetCurSel(m_nCategory);
	m_nEntry = 0;
	m_cmbEntry.SetCurSel(m_nEntry);

	////////////////////////////////////////////////////////
//	m_strRoot = "c:\\MSDEV\\_include";
//	m_strRoot = "c:\\MSDEV\\_LIB\\Cfg";

	m_strRoot = "D:\\MSDEV\\_include";
//	m_strRoot = "D:\\_work\\MSDEV\\_LIB\\Cfg";
//	m_strRoot = "D:\\_work\\MSDEV\\_LIB";
	////////////////////////////////////////////////////////

	SetEcxEntryToCmb(m_nCategory);



	//  
	PrepareListCtrl();




	EStringFormat sf;
	EString s1 = sf.PercentEncode(" William");


//	HtmlHelp(m_hWnd, s1, HH_DISPLAY_TOPIC, 0);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::SetEcxEntryToCmb(int nCategory, BOOL isResetContent, BOOL isAddPrefix)
{
	if(isResetContent)
	{
		m_cmbEntry.ResetContent();
		m_cmbEntry.AddString("<all>");
	}

	m_nEntry = 0;
	BOOL isScan = TRUE;
	EString crt, std = "\\StdEcx.h", root = m_strRoot;
	switch(nCategory)
	{
	case 0:
		m_cmbEntry.AddString("<root>");
		SetEcxEntryToCmb(2, FALSE, TRUE);
		SetEcxEntryToCmb(3, FALSE, TRUE);
		SetEcxEntryToCmb(4, FALSE, TRUE);
		isScan = FALSE;
		break;
	case 1:
		isScan = FALSE;
		break;
	case 2:
		crt = "crt\\";
		break;
	case 3:
		crt = "api\\"; m_nEntry = 1;
		break;
	case 4:
		crt = "mfc\\"; std = "\\MfcEcx.h";
		break;
	case 5:
		isScan = FALSE;
		break;
	}

	if(isScan)
	{
		EString s1;
		s1.Read(root + std);
		int i = 0;
		EString s21, s22;
		while(1)
		{
			i = s1.Find(crt, i);
			if(i == -1) break;
			i += 4;
			int j = s1.Find("\\", i);
			s21 = s1(i, j - 1);
			if(s22 != s21)
			{
				s22 = s21;
				if(isAddPrefix) s21.AddPrefix(crt);
				m_cmbEntry.AddString(s21);
			}
		}
	}
	m_cmbEntry.SetCurSel(m_nEntry);
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
BOOL CEcxLibDlg::ECX_GetVersion(LPCTSTR lpszFile, EString* pStr)
{
	EString strVersion;
	BOOL res = FALSE;

	CFile f;
	if(f.Open(lpszFile, CFile::modeRead))
	{
		DWORD dwLength = f.GetLength();
		PATHELEMENTS pes;
		_EcxSplitPath(lpszFile, &pes);

		EString ver;
		m_strCurrTitle = pes.szFile;
		m_strCurrTitle.MakeUpper();
		ver.Format("VERSION_%s", m_strCurrTitle);

		char* buf = new char[dwLength + 1];
		f.Read(buf, dwLength);
		f.Close();
		buf[dwLength] = '\0';
		char* tmp = buf;
		
		char* p0 = strstr(tmp, (LPCTSTR)ver);
		if(p0 != NULL)
		{
			p0+= ver.GetLength();
			skip_spaces(p0);
			char vver[16];
			vver[0] = '\0';
			if(*p0 == '\"')
			{
				_EcxGetString(&p0, vver, 0, 0, 0);
				strVersion = vver;
				res = TRUE;
				
			}
		}
		delete [] buf;
	}

	*pStr = strVersion;
	return res;
}


/*
#define A2W(lpa) (\
		((_lpa = lpa) == NULL) ? NULL : (\
			_convert = (lstrlenA(_lpa)+1),\
			ATLA2WHELPER((LPWSTR) alloca(_convert*2), _lpa, _convert, _acp)))


*/



/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
EString CEcxLibDlg::ECX_MakeVersion(FILETIME ftLastWriteTime)
{
	EString ver;

	SYSTEMTIME st;
	::FileTimeToSystemTime(&ftLastWriteTime, &st);

//	ver.Format("#define VERSION_%s   date", m_strCurrTitle);
	ver.Format(".%02d.%02d.%04d", st.wDay, st.wMonth, st.wYear);
	return ver;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
BOOL CEcxLibDlg::ECX_GetDate(LPCTSTR lpszDate, SYSTEMTIME* pSt)
{
	COleDateTime dt;
	if(dt.ParseDateTime(lpszDate))
	{
		pSt->wDay = dt.GetDay();
		pSt->wMonth = dt.GetMonth();
		pSt->wYear = dt.GetYear();
		return TRUE;
	}

	memset(pSt, 0, sizeof(SYSTEMTIME));
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
//  
void CEcxLibDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
HCURSOR CEcxLibDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/////////////////////////////////////////////////////////////////////////////
//  ListCtrl
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::PrepareListCtrl()
{
	//   
//	m_ListFiles.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT|LVS_EX_CHECKBOXES);
	m_ListFiles.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
	
	//  
	memset(m_col, 0, 16 * sizeof(COLUMN));

	m_ListFiles.InsertColumn(0, "Entry", LVCFMT_LEFT, 300);
	m_col[0].nType = COL_STRING;

	m_ListFiles.InsertColumn(1, "File", LVCFMT_LEFT, 260);
	m_col[1].nType = COL_STRING;
	
	m_ListFiles.InsertColumn(2, "Version", LVCFMT_LEFT, 90);
	m_col[2].nType = COL_DATE;
	
	m_ListFiles.InsertColumn(3, "Writed", LVCFMT_LEFT, 90);
	m_col[3].nType = COL_DATE;
	
	m_ListFiles.InsertColumn(4, "=", LVCFMT_LEFT, 30);
	m_col[4].nType = COL_DATE;
	
	m_ListFiles.InsertColumn(5, "Size", LVCFMT_RIGHT, 80);
	m_col[5].nType = COL_INTEGER;
	
//	m_ListFiles.InsertColumn(6, "", LVCFMT_LEFT, 100);
//	m_col[6].nType = COL_STRING;

	m_nColumnCount = m_ListFiles.GetHeaderCtrl()->GetItemCount();

	//  
	SetFilesToListCtrl();
	SetCheckFiles(TRUE);
	SetCount();
	
	//   "Entry"   "File"
	OnColumnclickIn(NULL, (LRESULT*)1);
	OnColumnclickIn(NULL, (LRESULT*)0);
}


/////////////////////////////////////////////////////////////////////////////
//      
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::SetCount()
{
	int nFilesCount = 0;
	for(int i=0; i<m_nFilesCount; i++)
	{
		if(m_ListFiles.GetCheck(i)) nFilesCount++;
	}
	CString strCount;
	strCount.Format("%d", nFilesCount);
	m_StatCount.SetWindowText(strCount);
}


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::SetCheckFiles(BOOL isCheck)
{
	for(int i=0; i<m_nFilesCount; i++) m_ListFiles.SetCheck(i, isCheck);
}


/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::SetFilesToListCtrl()
{
	int nCount = 0;
	m_ListFiles.DeleteAllItems();

	SETLISTPROCPARAM slpp;
	slpp.pListCtrl = &m_ListFiles;

	m_nFilesCount = 0;

	m_nCategory = m_cmbCrt.GetCurSel();
	m_cmbCrt.GetLBText(m_nCategory, m_strCategory);
	if(m_nCategory < 2) m_strCategory = "";

	m_nEntry = m_cmbEntry.GetCurSel();
	m_cmbEntry.GetLBText(m_nEntry, m_strEntry);
	if(m_nEntry < 1) m_strEntry = "";

	m_nRoot = m_strRoot.GetLength() + m_strCategory.GetLength();
	EnumFiles(m_strRoot, SetListProc, &slpp);
}


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
int CEcxLibDlg::EnumFiles(LPCSTR szRootFolder, PFN_ENUMFILESPROC pfnEnumFilesProc, void* lpParam)
{	
	//  
	CString strPath = szRootFolder;
	strPath += "\\*.*";
	EString s01 = m_strCategory;
	EString s02 = m_strEntry;
	if(m_nCategory == 0)
	{
		s01 = s02.Left(3);
		s02 = s02.Mid(4);
	}

	WIN32_FIND_DATA wfd;
	HANDLE hFile;

	//   
	if((hFile = ::FindFirstFile((LPCSTR)strPath, &wfd)) != INVALID_HANDLE_VALUE)
	{
		//   
		do
		{
			//   
			if(!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			{
				PATHELEMENTS pes;
				_EcxSplitPath(wfd.cFileName, &pes);
				if(CompareExt(pes.szExt))
				{
					m_strCurrFile.Format("%s\\%s", szRootFolder, wfd.cFileName);
					
					EString s1 = m_strCurrFile;
					s1.DeletePrefix(m_strRoot + '\\');
					EString s2, s3;
					s2 = s1.LeftTo('\\');
					s1.TrimLeft(s2 + '\\');
					s3 = s1.LeftTo('\\');

					if(m_nCategory > 0 || (m_nCategory == 0 && m_nEntry > 1))
					{
						if(m_nCategory == 1) if(s2[0] == '_') s01 = s2;
						if(s01 != s2) continue;
					}

					if(m_nEntry > 0)
					{
						if(m_nEntry == 1) if(s2[0] == '_' || s2.IsEmpty()) s02 = s3;
						if(s02 != s3) continue;
					}
	

					//   
					if(pfnEnumFilesProc != NULL) pfnEnumFilesProc(szRootFolder, m_nFilesCount, &wfd, lpParam);
					m_nFilesCount++;
				}
			}

			//   
			else
			{
				//    
				if(*wfd.cFileName != '.')
				{
					CString strRootFolder;
					strRootFolder.Format("%s\\%s", szRootFolder, wfd.cFileName);
					m_strCurrFolder = strRootFolder.Mid(m_nRoot + 1);
					m_strCurrFolder.TrimLeft('\\');

					//     
					EnumFiles((LPCSTR)strRootFolder, pfnEnumFilesProc, lpParam);

					int pos = m_strCurrFolder.ReverseFind('\\');
					strRootFolder = m_strCurrFolder.Left(pos);
					m_strCurrFolder = strRootFolder;
				}
			}
		}
		while(::FindNextFile(hFile, &wfd));
	}

	//  
	::FindClose(hFile);
	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
static char* g_ext[] =
{
	".h", ".cpp", ".c", ".clw", ".dsp", ".dsw", ".rc", ".lib"
};

BOOL CEcxLibDlg::CompareExt(char* pszExt)
{
	return _EcxCompareExt(pszExt, EXT_PARAM(g_ext));
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK SetListProc(LPCSTR szFolderPath, int nItem, WIN32_FIND_DATA* pwfd, void* lpParam)
{
	CEcxLibDlg* pDlg = g_pEcxLibDlg;
	SETLISTPROCPARAM* pefp = (SETLISTPROCPARAM*)lpParam;

//	char ch;
	CString str, s1;
	str.Format("%s", pwfd->cFileName);

	LVITEM lvItem;
	lvItem.mask = LVIF_TEXT;

	lvItem.iItem = nItem;
//	str.Format("%02u", lvItem.iItem);

	lvItem.iSubItem = 0;
//	lvItem.pszText = (LPTSTR)(LPCTSTR)str;
	lvItem.pszText = (LPTSTR)(LPCTSTR)g_pEcxLibDlg->m_strCurrFolder;
	pefp->pListCtrl->InsertItem(&lvItem);

	lvItem.iSubItem = 1;
	lvItem.pszText = pwfd->cFileName;
	BOOL res = pefp->pListCtrl->SetItem(&lvItem);


	lvItem.iSubItem = 2;
	EString ver;
	if(!g_pEcxLibDlg->ECX_GetVersion(g_pEcxLibDlg->m_strCurrFile, &ver))
	{
//		ver = g_pEcxLibDlg->ECX_MakeVersion(pwfd->ftLastWriteTime);
	}
	lvItem.pszText = (LPTSTR)(LPCTSTR)ver;
	pefp->pListCtrl->SetItem(&lvItem);

	lvItem.iSubItem = 3;
	CString upd;
	CTime time(pwfd->ftLastWriteTime);
	upd = time.Format("%d.%m.%Y");
	lvItem.pszText = (LPTSTR)(LPCTSTR)upd;
	pefp->pListCtrl->SetItem(&lvItem);
/*
	lvItem.iSubItem = 4;
	CString cra;
	CTime time1(pwfd->ftCreationTime);
	cra = time1.Format("%d.%m.%Y");
	lvItem.pszText = (LPTSTR)(LPCTSTR)cra;
	pefp->pListCtrl->SetItem(&lvItem);
*/
	
	lvItem.iSubItem = 5;
	str.Format("%d", pwfd->nFileSizeLow);
	lvItem.pszText = (LPTSTR)(LPCTSTR)str;
	pefp->pListCtrl->SetItem(&lvItem);


	pefp->pListCtrl->SetItemData(nItem, nItem);

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
//     
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::ExecuteApp()
{
	CString strApp, strArch, strDirectory;

	//  
	for(int i=0; i<m_nFilesCount; i++)
	{
		if(m_ListFiles.GetCheck(i))
		{
			//   
			strDirectory = m_szPath;
			strArch = m_ListFiles.GetItemText(i, 0);
			strApp.Format("%s\\arj32.exe e -y \"%s\\%s\" CSLU????.*", (LPCTSTR)strDirectory, m_szPath, (LPCTSTR)strArch);

			//    
			PROCESS_INFORMATION pi;
			STARTUPINFO si = { 0 };
			si.cb = sizeof(STARTUPINFO);
			si.dwFlags = STARTF_USESHOWWINDOW;
			si.wShowWindow = SW_HIDE;

			//  
			::SetCurrentDirectory(m_szPath);
			BOOL res = ::CreateProcess(NULL, (LPSTR)(LPCSTR)strApp, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);

			//    
			if(res)
			{
				//   
				::WaitForSingleObject(pi.hProcess, INFINITE);

				//   
				DWORD dwExitCode = 0;
				::GetExitCodeProcess(pi.hProcess, &dwExitCode);

				if(dwExitCode == 0)
				{
					LVITEM lvItem;
					lvItem.mask = LVIF_TEXT;
					lvItem.iItem = i;
					lvItem.iSubItem = 5;
					lvItem.pszText = "+";
					lvItem.cchTextMax = 1;
					m_ListFiles.SetItem(&lvItem);
				}

				//  
				::CloseHandle(pi.hProcess);
				::CloseHandle(pi.hThread);
			}
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
//      arj32.exe
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::DeleteFiles()
{
	CString strArch, strDirectory;

	for(int i=0; i<m_nFilesCount; i++)
	{
		strDirectory = m_szPath;
		CString strArch = m_ListFiles.GetItemText(i, 0);
		strDirectory += "\\";
		strDirectory += strArch;
//		::DeleteFile((LPCTSTR)strDirectory);
	}

	strDirectory = m_szPath;
	strDirectory += "\\arj32.exe";
	::DeleteFile((LPCTSTR)strDirectory);
}


/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::OnCheckAll() 
{
	SetCheckFiles(TRUE);
	SetCount();
	m_ListFiles.SetFocus();
}


/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::OnUncheckAll() 
{
	SetCheckFiles(FALSE);	
	SetCount();
	m_ListFiles.SetFocus();
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::OnStart() 
{
//	for(int i=0; i<m_nFilesCount; i++)
//	{
//		LVITEM lvItem;
//		lvItem.mask = LVIF_TEXT;
//		lvItem.iItem = i;
//		lvItem.iSubItem = 5;
//		lvItem.pszText = "2121";
//		lvItem.cchTextMax = 0;
//		m_ListFiles.SetItem(&lvItem);
//	}

//	ExecuteApp();
//	m_ListFiles.SetFocus();
}


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::OnItemChanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 0;

	SetCount();
}


/////////////////////////////////////////////////////////////////////////////
//   NM_DBLCLK
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::OnDblclkIn(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	*pResult = 0;

	int nItem = pNMListView->iItem;
	m_ListFiles.SetCheck(nItem, !m_ListFiles.GetCheck(nItem));
	
	SetCount();

	CString s1= m_strCurrFolder;
	CString s2= m_strCurrFile;
	CString s3= m_strCurrTitle;
}


/////////////////////////////////////////////////////////////////////////////
//   
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	DeleteFiles();
}


/////////////////////////////////////////////////////////////////////////////
//   LVN_COLUMNCLICK
/////////////////////////////////////////////////////////////////////////////
void CEcxLibDlg::OnColumnclickIn(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int i, nCol;

	if(pNMHDR != NULL)
	{
		NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
		nCol = pNMListView->iSubItem;
		*pResult = 0;
	}
	else
		nCol = (int)pResult;



	SORTDATA sdt;
	sdt.pListCtrl = &m_ListFiles;
	sdt.nCol = nCol;
	sdt.pCol = &m_col[nCol];

	m_col[nCol].nDirect = 1 - m_col[nCol].nDirect;
	m_ListFiles.SortItems(CompareProc, (DWORD)&sdt);
	
	for(i=0; i<m_nColumnCount; i++)
	{
		if(i != nCol) m_col[i].nDirect = 0;
	}

	//   lParam
	int nRecords = m_ListFiles.GetItemCount();
	for(i=0; i<nRecords; i++) m_ListFiles.SetItemData(i, i);
}

 
/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
int CALLBACK CompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	SORTDATA* pSdt = (SORTDATA*)lParamSort;

	CString s1 = pSdt->pListCtrl->GetItemText(lParam1, pSdt->nCol);
	CString s2 = pSdt->pListCtrl->GetItemText(lParam2, pSdt->nCol);


	int res;
	switch(pSdt->pCol->nType)
	{
		case COL_DATE:
		{
			SYSTEMTIME st1, st2;
			g_pEcxLibDlg->ECX_GetDate(s1, &st1);
			g_pEcxLibDlg->ECX_GetDate(s2, &st2);

			res = st1.wYear - st2.wYear;
			if(res == 0)
			{
				res = st1.wMonth - st2.wMonth;
				if(res == 0) res = st1.wDay - st2.wDay;
			}

			break;
		}

		case COL_STRING:
		{
			res = s1.CompareNoCase(s2);
			break;
		}

		case COL_INTEGER:
		{
			res = atoi((LPCTSTR)s1) - atoi((LPCTSTR)s2);
			break;
		}

		default:
			break;
	}

	return res * (2 * pSdt->pCol->nDirect - 1);
}


void CEcxLibDlg::OnOK() 
{
	m_ListFiles.SetFocus();
}

void CEcxLibDlg::OnSelchangeCrt() 
{
	m_nCategory = m_cmbCrt.GetCurSel();
	m_cmbCrt.SetCurSel(m_nCategory);
	m_ListFiles.SetFocus();
	SetEcxEntryToCmb(m_nCategory);

	//  
	SetFilesToListCtrl();
	SetCheckFiles(TRUE);
	SetCount();
	
	//   "Entry"   "File"
	OnColumnclickIn(NULL, (LRESULT*)1);
	OnColumnclickIn(NULL, (LRESULT*)0);
}

void CEcxLibDlg::OnSelchangeEntry() 
{
	m_nEntry = m_cmbEntry.GetCurSel();
	m_cmbEntry.SetCurSel(m_nEntry);
	m_ListFiles.SetFocus();

	//  
	SetFilesToListCtrl();
	SetCheckFiles(TRUE);
	SetCount();
	
	//   "Entry"   "File"
	OnColumnclickIn(NULL, (LRESULT*)1);
	OnColumnclickIn(NULL, (LRESULT*)0);	
}


void CEcxLibDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	if(bShow) m_ListFiles.SetFocus();
}
