// EcxLibDlg.h : header file
//

#if !defined(AFX_EcxLibDLG_H__A27FBCD5_B322_4FB0_AC09_9DD8BB050DD4__INCLUDED_)
#define AFX_EcxLibDLG_H__A27FBCD5_B322_4FB0_AC09_9DD8BB050DD4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CEcxLibDlg dialog



#include "StdEcx.h"
//#include "StdApi.h"





/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
typedef struct _SetListProcParam   // slpp
{
	CListCtrl* pListCtrl;

} SETLISTPROCPARAM;


/////////////////////////////////////////////////////////////////////////////
// 
/////////////////////////////////////////////////////////////////////////////
typedef BOOL (CALLBACK *PFN_ENUMFILESPROC) (LPCSTR, int, WIN32_FIND_DATA*, void*);


/////////////////////////////////////////////////////////////////////////////
//    
/////////////////////////////////////////////////////////////////////////////
enum _ColumnTypeID
{
	COL_STRING,
	COL_INTEGER,
	COL_DOUBLE,
	COL_DATE,
	COL_TIME,
};


/////////////////////////////////////////////////////////////////////////////
//  
/////////////////////////////////////////////////////////////////////////////
typedef struct tagCOLUMN  // col
{
	int nDirect;			//  
	int nType;				//    
	
} COLUMN;


typedef struct tagSORTDATA // sdt
{
	CListCtrl* pListCtrl;
	int nCol;
	COLUMN* pCol;
	
} SORTDATA;



class CEcxLibDlg : public CDialog
{
// Construction
public:
	CEcxLibDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CEcxLibDlg)
	enum { IDD = IDD_ECXLIB_DIALOG };
	CComboBox	m_cmbEntry;
	CComboBox	m_cmbCrt;
	CStatic	m_StatCount;
	CListCtrl	m_ListFiles;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEcxLibDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL


	void PrepareListCtrl();
	void SetFilesToListCtrl();
	void SetCheckFiles(BOOL isCheck);
	void SetCount();
	void DeleteFiles();

	BOOL CompareExt(char* pszExt);

	int EnumFiles(LPCSTR szRootFolder, PFN_ENUMFILESPROC pfnEnumFilesProc, void* lpParam);
	friend BOOL CALLBACK SetListProc(LPCSTR szFolderPath, int nItem, WIN32_FIND_DATA* pwfd, void* lpParam);
	friend int CALLBACK CompareProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);


	BOOL ECX_GetVersion(LPCTSTR lpszFile, EString* pStr);
	EString ECX_MakeVersion(FILETIME ftLastWriteTime);
	BOOL ECX_GetDate(LPCTSTR lpszDate, SYSTEMTIME* pSt);

	void SetEcxEntryToCmb(int nCategory, BOOL isResetContent = TRUE, BOOL isAddPrefix = FALSE);
	



	void ExecuteApp();


// Implementation
protected:
	HICON m_hIcon;


	CString m_strCurrFolder;
	CString m_strCurrFile;
	CString m_strCurrTitle;

	int m_nCategory;
	CString m_strCategory;
	int m_nEntry;
	CString m_strEntry;
	CString m_strRoot;
	int m_nRoot;
	char m_szPath[MAX_PATH];
	int m_nFilesCount;

	PATHELEMENTS m_pes;

	COLUMN m_col[16];
	int m_nColumnCount;

	// Generated message map functions
	//{{AFX_MSG(CEcxLibDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCheckAll();
	afx_msg void OnUncheckAll();
	afx_msg void OnStart();
	afx_msg void OnItemChanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestroy();
	afx_msg void OnDblclkIn(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclickIn(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeCrt();
	virtual void OnOK();
	afx_msg void OnSelchangeEntry();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EcxLibDLG_H__A27FBCD5_B322_4FB0_AC09_9DD8BB050DD4__INCLUDED_)
