// TextParsing.h : header file
//

#ifndef __TEXTPARSING_H__
#define __TEXTPARSING_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
//  TextParsing.h
/////////////////////////////////////////////////////////////////////////////
#define VERSION_TEXTPARSING   "18.10.2010"
#pragma message ("TextParsing.h : " VERSION_TEXTPARSING)



////////////////////////////////////////////////////////////////////////////
//    lpBr1...lpBr2
////////////////////////////////////////////////////////////////////////////
typedef struct _BlockInfo  // binf
{
	char* pBuff;

	char* lpBr1;
	char* lpBr2;
	BOOL isCase;

	char* pBeg;
	int nLength;

} BLOCK_INFO;


////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////
enum _SkipNonInfoType
{
	SKIP_PASCAL_COMMENT		= 0x00000001,
	SKIP_HTML_COMMENT		= 0x00000002,
	SKIP_VBSCRIPT_COMMENT	= 0x00000004,
	SKIP_BATCH_COMMENT		= 0x00000008,

	SKIP_SPACES				= 0x00000010,
	SKIP_ONELINE_COMMENT	= 0x00000020,
	SKIP_MULTYLINE_COMMENT	= 0x00000040,
	SKIP_NEWLINE_BREAK		= 0x00000080,

	SKIP_STATE_FUNCTION		= 0x00000100,
	SKIP_CUSTOM_FUNCTION	= 0x00000200,

	SKIP_BASE				= SKIP_SPACES | SKIP_ONELINE_COMMENT | SKIP_MULTYLINE_COMMENT | SKIP_NEWLINE_BREAK,
	SKIP_ALL				= 0xFFFFFFFF
};



////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////
typedef BOOL (CALLBACK *PFN_SKIPNONINFOPROC) (char**, int);



////////////////////////////////////////////////////////////////////////////
#endif // __TEXTPARSING_H__
